%% code to extract soil misture from different data sources
%% Part 1 : SMAP DA time series (MEAN)
clear all
close all
clc

% run the lvt to extract the model, SMAP, and USDA ARS soil moisture

wd = pwd;

fig = strcat(wd, '/fig');

if ~exist(fig, 'dir')
    mkdir(fig)
end

cd (wd)


station_name = {'Little_Washita' , 'Fort_Cobb' };
data_source = { 'ol.da', 'smapDAobs', 'ens_spread' };


%for count = 1 : length(data_source)
%    count

for id =1 : length(station_name)
    id;
    
    % read ol
    cd (wd)
    cd (['STATS.' data_source{1} ])
    fname = ['MEAN_' station_name{id} '.dat'];
    if exist (fname, 'file') ~=0
        data = load (fname) ;
    end
    % format
    % Analysis data sources: "ol soil moisture" "smap da soil moisture"
    ol = data(:,6);   %  soil moisture noah 36 ol
    da = data(:,12);   % soil moisture noah 36 smap da
    dates = datenum([data(:,1),data(:,2),data(:,3)]);
    ol(ol == -9999) = NaN;
    da(da == -9999) = NaN;
    dates(dates == -9999) = NaN;
    clear data
    
        
    % read DAobs
    cd (wd)
    cd (['STATS.' data_source{2} ])
    fname = ['MEAN_' station_name{id} '.dat'];
    if exist (fname, 'file') ~=0
        data = load (fname) ;
    end
    % format
    % Analysis data sources: "ol soil moisture" "ol soil moisture"
    DAobs = data(:,6);   %  soil moisture noah 36
    dates2 = datenum([data(:,1),data(:,2),data(:,3)]);
    DAobs(DAobs == -9999) = NaN;
    dates2(dates2 == -9999) = NaN;
    clear data
    
    cd (wd)
    
    cd fig
    
    fh = figure ;
    set (fh, 'position', [100 ,100 ,1200, 700])
    %sunplot (2,1,1)
    plot (dates, ol); hold on ;
    plot (dates, da, '-r');
    plot (dates2, DAobs, 'o', 'MarkerSize',4,...
               'MarkerEdgeColor','k',...
               'MarkerFaceColor','green' );
    %bar (dates3, Ens)
    legend ('OL', 'DA', 'DAobs') %, 'Ens.spread'
    datetick('x','mmmyy','keepticks','keeplimits')
    title (  sprintf( '%s ', 'OL, DA, Station name :',station_name{id}) ,'Interpreter', 'none')
    %title(sprintf('%s_%d',mytitle{i},i), 'Interpreter', 'none');
    grid on
    ylabel ( 'soil moisture ')
    %xlim ([736035,736950 ])
    %xlim ([736450,736950 ])
    %        sunplot (2,1,2)
    %        plot (dates, ol36); hold on ;
    %        plot (dates, ol39, 'r');
    %        plot (dates2, ensNoDA36, '+b');
    %        plot (dates2, ensNoDA39, '+r');
    %        legend ('OL Noah36', 'OL Noah 39', 'EnsNoDA 36', 'EnsNoDA 39') %
    %        legend ('OL Noah36', 'OL Noah 39') %
    %        datetick('x','mmmyy','keepticks','keeplimits')
    %        title (  sprintf( '%s ', 'OL, Station name :',station_name{id}) ,'Interpreter', 'none')
    %title(sprintf('%s_%d',mytitle{i},i), 'Interpreter', 'none');
    %        grid on
    %        ylabel ( 'soil moisture ')
    
    
    fig_dims = get(gcf,'position');
    set(gcf,'Paperunits','points',...
        'PaperPosition',[0 0 fig_dims(3) fig_dims(4)]) ;
    set(gcf,'color','w');set(gcf, 'InvertHardCopy', 'off');
    set(gcf,'PaperPositionMode','auto'); box on; grid on ; %axis square;
    print(gcf,'-dpng','-r200',['OL_DA_' station_name{id} '.png']);

end

cd (wd)
% 
%     
%     
